<?php

namespace Drupal\smart_content_a_b\Plugin\smart_content\SegmentSetStorage;

use Drupal\smart_content_a_b\Entity\SegmentSetAB;
use Drupal\smart_content\SegmentSetStorage\SegmentSetStorageBase;

/**
 * Provides a 'segment_set' SegmentSetStorage.
 *
 * @SmartSegmentSetStorage(
 *  id = "smart_content_a_b",
 *  label = @Translation("A/B Tests"),
 *  global = true,
 *  deriver = "Drupal\smart_content_a_b\Plugin\smart_content\SegmentSetStorage\Derivative\GlobalSegmentSetABDeriver"
 * )
 */
class GlobalSegmentSetAB extends SegmentSetStorageBase {

  /**
   * {@inheritdoc}
   */
  public function load() {
    list($plugin_id, $entity_id) = explode(':', $this->getPluginId());
    return SegmentSetAB::load($entity_id)->getSegmentSet();
  }

  public function getAttachedSettings() {
    $settings = parent::getAttachedSettings();

    list($plugin_id, $entity_id) = explode(':', $this->getPluginId());
    $settings['tests'][$entity_id] = count($this->getSegmentSet()->getSegments());
    return $settings;
  }

  public function getLibraries() {
    return parent::getLibraries(); // TODO: Change the autogenerated stub
  }
}
